﻿#include "widget.h"
#include <QFileDialog>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>

Widget::Widget(QWidget *parent) :
    QWidget(parent)
{
    setupUi(this);
    lineEditServer->setText(QLatin1String("ftp://servername/home/username/")
                            + QChar(0x65E5) + QChar(0x672C) + QChar(0x8A9E)
                            + QLatin1String(".txt"));
    setWindowTitle(QT_VERSION_STR);
}

void Widget::on_pushButton_clicked()
{
    lineEditFileName->setText(QFileDialog::getOpenFileName());
}

void Widget::on_pushButton_2_clicked()
{
    const QString fn = lineEditFileName->text().trimmed();
    qDebug() << __FUNCTION__ << fn;
    QFile *file  = new QFile(fn, this);
    if (!file->open(QIODevice::ReadOnly) ) {
        qWarning() << __FUNCTION__ << file << file->errorString();
        return;
    }

    const QString u = lineEditServer->text().trimmed();
    qDebug() << __FUNCTION__ << "URLstring" << u
          << "\nUtf8/Hex:" << u.toUtf8().toHex();

    QUrl urlToUpload(u);
    urlToUpload.setUserName(lineEditUserName->text());
    urlToUpload.setPassword(lineEditPassword->text());
    urlToUpload.setPort(21);
    if (!urlToUpload.isValid()) {
        qWarning() << __FUNCTION__ << fn << urlToUpload.errorString();
        return;
    }
    qDebug() << __FUNCTION__ << urlToUpload
             << "\ntoEncoded=" << urlToUpload.toEncoded();

    QNetworkAccessManager *nam = new QNetworkAccessManager;
    QNetworkRequest requp(urlToUpload);
    QNetworkReply *reply = nam->put(requp,file);

    connect(nam, SIGNAL(finished(QNetworkReply*)),this, SLOT(requestFinished(QNetworkReply*)));
    connect(reply, SIGNAL(uploadProgress(qint64, qint64)), SLOT(uploadProgress(qint64, qint64)));
    connect(reply, SIGNAL(finished()), SLOT(uploadDone()));

}

void Widget::requestFinished(QNetworkReply *reply)
{
    qDebug() << Q_FUNC_INFO;
    qDebug() << "Error Code: " << reply->error();

}

void Widget::uploadProgress(qint64 qi1, qint64 qi2)
{
    qDebug() << Q_FUNC_INFO;
    qDebug() << qi1 << qi2;

}

void Widget::uploadDone()
{
    qDebug() << Q_FUNC_INFO;
}
